#ifndef ADDER_H
#define ADDER_H



#include <systemc.h>
#include "global.h"

#ifdef WITH_OBSERVER
extern mon_observer* observer;
#endif

#ifdef MONITOR_2
#include "monitor2.h"
#endif

class adder : public sc_module {

  // Monitoring

#ifdef MONITOR_0
friend class test_monitor0;
#endif



  SC_HAS_PROCESS(adder);
  
 public:
  
  // The constructor
  adder(sc_module_name module_name, int num_mons);
  
  sc_in < int > input1, input2;
  sc_out< int > result;

  void driver();
  void do_add1();

 protected:
  
  int _a;
  sc_event addition_event;
  sc_event driver_event;
  sc_event add1_activate_event;
}; //class



#endif
