#ifndef MONITOR3_H
#define MONITOR3_H


#include <systemc>
#include "adder.h" // Need access to the fields of the adder objects
#include "debug_printer.h"

/**
 * All properties are a subclass of mon_property, and inherit all
 * virtual functions.
 */
class monitor3 : public mon_prototype {

 public:
  
  // The constructor
  monitor3(mon_observer* obs, adder* obj1);

  // Callbacks
  virtual const char* to_string() const;
  virtual void callback_event_notified(sc_event* event);
  

 private: 
  mon_observer* observer;
  adder* object1;
};


#endif
